from tkinter import *
from random import randint

def generate_maze(ms):
    visited_cells = []
    walls = []
    revisited_cells = []

    maze = [[0 for _ in range(ms)] for _ in range(ms)]

    def check_neighbours(ccr, ccc):
        neighbours = [
            [ccr, ccc - 1, ccr - 1, ccc - 2, ccr, ccc - 2, ccr + 1, ccc - 2, ccr - 1, ccc - 1, ccr + 1, ccc - 1],  # left
            [ccr, ccc + 1, ccr - 1, ccc + 2, ccr, ccc + 2, ccr + 1, ccc + 2, ccr - 1, ccc + 1, ccr + 1, ccc + 1],  # right
            [ccr - 1, ccc, ccr - 2, ccc - 1, ccr - 2, ccc, ccr - 2, ccc + 1, ccr - 1, ccc - 1, ccr - 1, ccc + 1],  # top
            [ccr + 1, ccc, ccr + 2, ccc - 1, ccr + 2, ccc, ccr + 2, ccc + 1, ccr + 1, ccc - 1, ccr + 1, ccc + 1]]  # bottom
        visitable_neighbours = []
        for i in neighbours:
            if 0 < i[0] < (ms - 1) and 0 < i[1] < (ms - 1):
                if maze[i[2]][i[3]] or maze[i[4]][i[5]] or maze[i[6]][i[7]] or maze[i[8]][i[9]] or \
                        maze[i[10]][i[11]]:
                    walls.append(i[0:2])
                else:
                    visitable_neighbours.append(i[0:2])
        return visitable_neighbours

    scr = randint(1, ms - 2)
    scc = ms - 2
    # start_color = 'Green'
    ccr, ccc = scr, scc

    maze[ccr][ccc] = 1
    finished = False
    while not finished:
        visitable_neighbours = check_neighbours(ccr, ccc)
        if len(visitable_neighbours) != 0:
            d = randint(1, len(visitable_neighbours)) - 1
            ncr, ncc = visitable_neighbours[d]
            maze[ncr][ncc] = 1
            visited_cells.append([ncr, ncc])
            ccr, ccc = ncr, ncc
        if len(visitable_neighbours) == 0:
            try:
                ccr, ccc = visited_cells.pop()
                revisited_cells.append([ccr, ccc])

            except:
                finished = True

    maze_str = ""
    flat_maze = [item for sublist in maze[1:-1] for item in sublist[1:-1]]
    output = ','.join(map(str, map(int, flat_maze)))

    return output

# Write the flattened maze to a text file
with open('maze_examples.txt', 'w') as file:
    for i in range(100):
        maze = generate_maze(102)
        file.write(maze + '\n')

